using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Reflection;

namespace II320_SampleCS
{
    public partial class FormIntSetting : Form
    {
        const int _MAX_DIO_BIT = 32;
        Color _ENABLE_COLOR = Color.FromArgb(0xFF, 0x80, 0xFF);
        Color _DISABLE_COLOR = Color.FromArgb(0x80, 0x80, 0x80);
        Color _RISE_COLOR = Color.FromArgb(0x00, 0xFF, 0xFF);
        Color _FALL_COLOR = Color.FromArgb(0x80, 0x80, 0x80);
        const string _ENABLE_TEXT = "ENB";
        const string _DISABLE_TEXT = "DIS";
        const string _RISE_TEXT = "";
        const string _FALL_TEXT = "";

        Label[] m_di_enable = new Label[_MAX_DIO_BIT];
        Label[] m_di_edge = new Label[_MAX_DIO_BIT];
        Label[] m_waitevent_di_enable = new Label[_MAX_DIO_BIT];


        public uint di_enable;
        public uint di_edge;
        public uint int_enable;
        public uint int_edge;
        public uint wait_event_di_enable;
        public uint wait_event_int_enable;
        public uint di_int_mode;
        

        public FormIntSetting()
        {
            InitializeComponent();

            di_enable = 0;
            di_edge = 0;
            int_enable = 0;
            int_edge = 0;
            wait_event_di_enable = 0;
            wait_event_int_enable = 0;
            di_int_mode = 0;

            this.DialogResult = DialogResult.Cancel;
        }

        private void FormIntSetting_Load(object sender, EventArgs e)
        {
            // Rg[̔z
            for (int i = 0; i < _MAX_DIO_BIT; i++)
            {
                string fieldname_dienb = string.Format("labelDIEnable{0:d2}", i);
                this.m_di_enable[i] = (Label)this.GetType().GetField(fieldname_dienb, BindingFlags.Public | BindingFlags.NonPublic | BindingFlags.Instance | BindingFlags.DeclaredOnly).GetValue(this);

                string fieldname_diedge = string.Format("labelDIEdge{0:d2}", i);
                this.m_di_edge[i] = (Label)this.GetType().GetField(fieldname_diedge, BindingFlags.Public | BindingFlags.NonPublic | BindingFlags.Instance | BindingFlags.DeclaredOnly).GetValue(this);

                string fieldname_wedienb = string.Format("labelWaitEventDIEnable{0:d2}", i);
                this.m_waitevent_di_enable[i] = (Label)this.GetType().GetField(fieldname_wedienb, BindingFlags.Public | BindingFlags.NonPublic | BindingFlags.Instance | BindingFlags.DeclaredOnly).GetValue(this);
            }

            //  {^CLICKCxgǉ
            foreach (Label lb in m_di_enable)
                lb.Click += new EventHandler(DIEnable_Button_Click);
            foreach (Label lb in m_di_edge)
                lb.Click += new EventHandler(DIEdge_Button_Click);
            foreach (Label lb in m_waitevent_di_enable)
                lb.Click += new EventHandler(WaitEventDIEnable_Button_Click);

            // 
            for (int i = 0; i < _MAX_DIO_BIT; i++)
            {
                _disp_enable_button(m_di_enable[i], (0 != ((di_enable >> i) & 0x01)));
                _disp_edge_button(m_di_edge[i], (0 != ((di_edge >> i) & 0x01)));
                _disp_enable_button(m_waitevent_di_enable[i], (0 != ((wait_event_di_enable >> i) & 0x01)));
            }
            _disp_enable_button(labelINTEnable, (0 != int_enable));
            _disp_edge_button(labelINTEdge, (0 != int_edge));
            _disp_enable_button(labelWaitEventINTEnable, (0 != int_enable));
            if (0 == di_int_mode) radioButtonDIINTMode0.Checked = true;
            else radioButtonDIINTMode1.Checked = true;
        }

        private void DIEnable_Button_Click(object sender, EventArgs e)
        {
            foreach (Label lb in m_di_enable)
            {
                if (sender.Equals(lb))
                    _disp_enable_button(lb, !_get_status(lb));
            }
        }

        private void DIEdge_Button_Click(object sender, EventArgs e)
        {
            foreach (Label lb in m_di_edge)
            {
                if (sender.Equals(lb))
                    _disp_edge_button(lb, !_get_status(lb));
            }
        }

        private void WaitEventDIEnable_Button_Click(object sender, EventArgs e)
        {
            foreach (Label lb in m_waitevent_di_enable)
            {
                if (sender.Equals(lb))
                    _disp_enable_button(lb, !_get_status(lb));
            }
        }

        private void labelINTEnable_Click(object sender, EventArgs e)
        {
            _disp_enable_button(labelINTEnable, !_get_status(labelINTEnable));
        }

        private void labelINTEdge_Click(object sender, EventArgs e)
        {
            _disp_edge_button(labelINTEdge, !_get_status(labelINTEdge));
        }

        private void labelWaitEventINTEnable_Click(object sender, EventArgs e)
        {
            _disp_enable_button(labelWaitEventINTEnable, !_get_status(labelWaitEventINTEnable));
        }

        private bool _get_status(Label lb)
        {
            if (lb.Text == _ENABLE_TEXT || lb.Text == _RISE_TEXT)
                return true;
            else
                return false;
        }

        private void _disp_enable_button(Label lb, bool value)
        {
            lb.BackColor = value?_ENABLE_COLOR:_DISABLE_COLOR;
            lb.Text = value?_ENABLE_TEXT:_DISABLE_TEXT;
        }

        private void _disp_edge_button(Label lb, bool value)
        {
            lb.BackColor = value ? _RISE_COLOR : _FALL_COLOR;
            lb.Text = value ? _RISE_TEXT : _FALL_TEXT;
        }

        private void buttonOK_Click(object sender, EventArgs e)
        {
            uint one = 0x01;
            di_enable = 0;
            di_edge = 0;
            wait_event_di_enable = 0;
            for (int i = 0; i < _MAX_DIO_BIT; i++)
            {
                di_enable |= _get_status(m_di_enable[i]) ? (one << i) : 0;
                di_edge |= _get_status(m_di_edge[i]) ? (one << i) : 0;
                wait_event_di_enable |= _get_status(m_waitevent_di_enable[i]) ? (one << i) : 0;
            }
            int_enable = (uint)(_get_status(labelINTEnable) ? 1 : 0);
            int_edge = (uint)(_get_status(labelINTEdge) ? 1 : 0);
            wait_event_int_enable = (uint)(_get_status(labelWaitEventINTEnable) ? 1 : 0);
            if (radioButtonDIINTMode0.Checked) di_int_mode = 0;
            else di_int_mode = 1;

            this.DialogResult = DialogResult.OK;
        }

        private void buttonCancel_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.Cancel;
        }


    }
}