using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace II320_SampleCS
{
    public partial class FormNoiseFilterSetting : Form
    {
        public int m_int_width;
        public int m_int_scale;
        public int m_di_width;
        public int m_di_scale;

        public FormNoiseFilterSetting()
        {
            InitializeComponent();
            this.DialogResult = DialogResult.Cancel;
        }

        private void FormNoiseFilterSetting_Load(object sender, EventArgs e)
        {
            comboBoxIntWidth.SelectedIndex = m_int_width;
            comboBoxIntScale.SelectedIndex = m_int_scale;
            comboBoxDiWidth.SelectedIndex = m_di_width;
            comboBoxDiScale.SelectedIndex = m_di_scale;

            _disp_time(textBoxIntTime, _get_width_time(comboBoxIntWidth.SelectedIndex) * comboBoxIntScale.SelectedIndex);
            _disp_time(textBoxDiTime, _get_width_time(comboBoxDiWidth.SelectedIndex) * comboBoxDiScale.SelectedIndex);
        }

        private void comboBoxIntWidth_SelectedIndexChanged(object sender, EventArgs e)
        {
            _disp_time(textBoxIntTime, _get_width_time(comboBoxIntWidth.SelectedIndex) * comboBoxIntScale.SelectedIndex);
        }

        private void comboBoxDiWidth_SelectedIndexChanged(object sender, EventArgs e)
        {
            _disp_time(textBoxDiTime, _get_width_time(comboBoxDiWidth.SelectedIndex) * comboBoxDiScale.SelectedIndex);
        }

        private void comboBoxIntScale_SelectedIndexChanged(object sender, EventArgs e)
        {
            _disp_time(textBoxIntTime, _get_width_time(comboBoxIntWidth.SelectedIndex) * comboBoxIntScale.SelectedIndex);
        }

        private void comboBoxDiScale_SelectedIndexChanged(object sender, EventArgs e)
        {
            _disp_time(textBoxDiTime, _get_width_time(comboBoxDiWidth.SelectedIndex) * comboBoxDiScale.SelectedIndex);
        }

        void _disp_time(TextBox tx, double time)
        {
            if (1 > time / 1000)
                tx.Text = string.Format("{0}(ns)", time);
            else if (1 > time / 1000000)
                tx.Text = string.Format("{0}(us)", time / 1000);
            else
                tx.Text = string.Format("{0}(ms)", time / 1000000);
        }

        double _get_width_time(int index)
        {
            double ret = 0.0;
            switch (index)
            {
                case 0: ret = 0; break;
                case 1: ret = 60.6; break;
                case 2: ret = 121.2; break;
                case 3: ret = 242.4; break;
                case 4: ret = 484.8; break;
                case 5: ret = 969.7; break;
                case 6: ret = 1830; break;
                case 7: ret = 3870; break;
                case 8: ret = 7750; break;
                case 9: ret = 15150; break;
                case 10: ret = 31030; break;
                case 11: ret = 62060; break;
                case 12: ret = 124100; break;
                case 13: ret = 248200; break;
                case 14: ret = 496400; break;
                case 15: ret = 992900; break;
            }
            return ret;
        }

        private void buttonOK_Click(object sender, EventArgs e)
        {
            m_int_width = comboBoxIntWidth.SelectedIndex;
            m_int_scale = comboBoxIntScale.SelectedIndex;
            m_di_width = comboBoxDiWidth.SelectedIndex;
            m_di_scale = comboBoxDiWidth.SelectedIndex;
            this.DialogResult = DialogResult.OK;
        }

        
    }
}